=== Puma/examples/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

SUBDIRS := $(shell find $(shell pwd) -type d -maxdepth 1 -mindepth 1)
SUBDIRS := $(filter-out %/CVS, $(SUBDIRS))
SUBDIRS := $(SUBDIRS)

ifeq ($(SUBDIRS),)

define propagate
endef

else

# define how to propagate a target into the subdirectories
define propagate
	for DIR in $(SUBDIRS); \
	  do cd $$DIR; \
	  $(MAKE) $(MAKECMDGOALS); \
	done
endef

endif

#-------------------------------------------------
# rules
#-------------------------------------------------

all clean:
	@$(propagate)
