=== Puma/tools/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

SUBDIRS := $(shell find $(shell pwd) -maxdepth 1 -mindepth 1 -type d)
SUBDIRS := $(filter-out %/CVS %/scripts, $(SUBDIRS))
SUBDIRS := $(SUBDIRS)

ifeq ($(SUBDIRS),)

define propagate
endef

else

# define how to propagate a target into the subdirectories
define propagate
	for DIR in $(SUBDIRS); \
	  do cd $$DIR; \
	  $(MAKE) -s $(MAKECMDGOALS); \
	done
endef

endif

#-------------------------------------------------
# rules
#-------------------------------------------------

all clean:
	@$(propagate)
