=== AspectC++/examples/CFlow/Makefile ===
CXX ?= g++

cflow: main.cc
	$(CXX) $(CXXFLAGS) -o cflow main.cc
