=== AspectC++/examples/IconCache/Makefile ===
CXX ?= g++

icon: main.cc IconCache.cc
	$(CXX) $(CXXFLAGS) -o icon main.cc IconCache.cc
