=== AspectC++/examples/Instances/Makefile ===
CXX ?= g++

instances: main.cc
	$(CXX) $(CXXFLAGS) -o instances main.cc
