=== AspectC++/examples/ObserverPattern/Makefile ===
CXX ?= g++

observer_pattern: AnalogClock.cc DigitalClock.cc ClockTimer.cc main.cc ac_gen.cc
	$(CXX) $(CXXFLAGS) -o $@ AnalogClock.cc DigitalClock.cc ClockTimer.cc main.cc ac_gen.cc
