=== AspectC++/tests/Bug209/Makefile ===
ACFLAGS ?= --real-instances
include ../Makefile.generic
