## aspectc++ 1.0

=== AspectC++/Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # libxml2 settings
 ifeq ($(_TARGET),win32)
 	LIBXML2_INC := `mingw32-xml2-config --cflags` 
-	LIBXML2_LIB := `mingw32-xml2-config --libs` -lwsock32
+	LIBXML2_LIB := `mingw32-xml2-config --libs`
 	EXT=.exe
 else
 	LIBXML2_INC := `xml2-config --cflags` 
@@ -31,6 +31,8 @@
 ifneq ($(SHARED),)
 	LDFLAGS += -Wl,-Bdynamic
 endif
+else
+	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lPuma
 endif
 
 LDFLAGS += $(LIBXML2_LIB)
@@ -50,6 +52,11 @@
 	CXXFLAGS += -pg
 endif
 
+# use the new libacmodel
+ifneq ($(ACMODEL),)
+  CPPFLAGS += -DACMODEL -I$(ACMODEL)/include
+	LDFLAGS  += -L$(ACMODEL)/lib/$(TARGET) -lacmodel 
+endif
 
 
 
@@ -82,10 +89,9 @@
 MAKE ?= make
 
 # ac++ settings for tests
-ACFLAGS := -v 9
-
-ACEXAMPLES = FigureObserver Instances Trace CFlow ID Action Cache IconCache \
-	     Order
+ACFLAGS := -k -v 9
+
+ACEXAMPLES = coverage helloworld modules profiling singleton
 
 
 .PHONY: $(ACEXAMPLES) 
@@ -96,6 +102,9 @@
 # ******************************
 
 all: showtarget dirs $(PROG)
+
+strip: $(PROG)
+	@$(STRIP) $<
 
 showtarget:
 	@echo "---"
@@ -111,6 +120,8 @@
 	@echo Making it clean.
 	@rm -rf  core core.* *~ $(PROG) $(OBJECTDIR) $(DEPDIR) $(ERROR_FILE)
 
+cleanall:	doxygen-clean clean
+
 dirs: $(DIRS)
 
 test: $(PROG)$(EXT) testall
@@ -123,8 +134,25 @@
 	@rm -rf examples/*-out
 	@rm -rf examples/*.acp
 
-.PHONY: all test  clean  example  examplerun  exampleclean \
-        showtarget
+doxygen:
+	@echo "Making AspectC++ documentation with doxygen"
+	@doxygen doc/doxygen.conf && echo "=> see doc/doxygen/html/index.html"
+
+doxygen-clean:
+	@rm -rf doc/doxygen
+
+regressiontest:
+	rm -rf RegressionTests.tar.bz2 RegressionTestsTmp
+	mkdir RegressionTestsTmp
+	svn export tests/ RegressionTestsTmp/tests/
+	sed -i '1iMAKELEVEL=1' RegressionTestsTmp/tests/Makefile
+	cd RegressionTestsTmp && tar cvfj RegressionTests.tar.bz2 tests/
+	mv RegressionTestsTmp/RegressionTests.tar.bz2 .
+	cd ..
+	rm -rf RegressionTestsTmp
+
+.PHONY: all test clean cleanall example examplerun exampleclean \
+        showtarget doxygen doxygen-clean
