=== Puma/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

ROOT    ?= $(shell pwd)
TARGET  ?= linux-release
AC      ?= ac++
PREFIX  ?= /usr/local 
MINUSJ  ?= 1 

include vars.mk
include files.mk

LIBDIR  := $(ROOT)/lib/$(TARGET)
GENDIR  := $(ROOT)/gen-$(RELEASE)

INCDIR  := $(ROOT)/include
OBJDIR  := $(GENDIR)/obj-$(_TARGET)
STEP1   := $(GENDIR)/step1
STEP2   := $(GENDIR)/step2

CONFIG  := $(GENDIR)/puma.cfg
ACNEWREPO ?= $(GENDIR)/acpp.repo

# exported variables
export GENDIR INCDIR LIBDIR OBJDIR STEP1 STEP2
export ROOT TARGET AC DONTWEAVE CONFIG MINUSJ ACNEWREPO
export ORASOURCES LEMSOURCES SOURCES CSOURCES ASPECTS 

# suppress reporting directory changes
MAKE := $(MAKE) --no-print-directory

#-------------------------------------------------
# rules
#-------------------------------------------------

all: showinfo src

weave: showinfo src

compile: showinfo src

showinfo:
	@echo 
	@echo "---"
	@echo "Making PUMA for TARGET=$(TARGET)"
	@echo "  Extensions = $(EXTENSIONS)"
	@echo "---"
	@echo 

tools:
	@cd $(ROOT)/tools && $(MAKE)

src: tools
	@cd $(ROOT)/src && $(MAKE) $(MAKECMDGOALS)

examples: src
	@cd $(ROOT)/examples && $(MAKE)

doc:
	@echo "Generating Puma reference manual..."
	@doxygen doc/RefMan/doxygen.conf && echo "=> see doc/RefMan/html/index.html"

install: src
	@echo "Installing library and headers..."
	@mkdir -p $(PREFIX)/lib
	@cp -pv $(LIBDIR)/libPuma.* $(PREFIX)/lib
	@mkdir -p $(PREFIX)/include/Puma
	@cp -pv $(INCDIR)/Puma/*.*h $(PREFIX)/include/Puma

uninstall: 
	@echo "Uninstalling library and headers..."
	@rm -fv $(PREFIX)/lib/libPuma.*
	@rm -rfv $(PREFIX)/include/Puma

clean: tools-clean
	@cd $(ROOT)/src && $(MAKE) clean

tools-clean:
	@cd $(ROOT)/tools && $(MAKE) -s clean

examples-clean:
	@cd $(ROOT)/examples && $(MAKE) -s clean

docs-clean:
	@echo "Making docs clean..."
	@rm -rf $(ROOT)/doc/RefMan/html

cleanall: test-clean examples-clean tools-clean docs-clean
	@echo "Making completely clean..."
	@rm -rf $(ROOT)/lib
	@rm -rf $(ROOT)/gen-*

distclean: clean examples-clean docs-clean
	@cd $(ROOT)/src && $(MAKE) distclean

libclean:
	@echo "Removing library and object files..."
	@rm -f $(LIBDIR)/libPuma.*
	@rm -rf $(OBJDIR)
	@rm -rf $(STEP2)/dep

test: test-all

test-%:
	@echo "Making tests $*..."
	@$(MAKE) -C tests -s $*

#-------------------------------------------------
# targets
#-------------------------------------------------

.PHONY: all tools src install examples distclean cleanall \
clean tools-clean examples-clean libclean weave compile uninstall doc
