=== AspectC++/tests/Makefile ===
--- 
+++ 
@@ -4,19 +4,25 @@
 directory of the ApectC++ source tree instead)
 endif
 
+SHELL=/bin/bash
+
 ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
           Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
           ArrayMangling MatchExpr ConsDesAdvice NestedClassFuncAdvice \
           MacroCall CallAdvice CallOnRef TemplateExtCall Bug190 Bug191 Bug192 \
-	  Order NonInlineIntros JPType PragmaOnce Bug207 Bug209 \
+	  Order NonInlineIntros JPType PragmaOnce Bug207 \
 	  AbstractDerivedAspect PragmaOnceObserver ThatConst PrivateResult \
           VoidArg ArrayWrapper Bug216 Bug228 ExecAdviceRecursive ExternC \
 	  ThatContext IntroIncludes Bug234 Bug234-2 Bug235 Bug239 \
-	  ExecAdviceNewDelete CallPostfixOp STLString CFlowCycle \
+	  ExecAdviceNewDelete ExecAdviceFriend CallPostfixOp STLString \
+	  CFlowCycle Bug368 \
 	  IntroInBase NonInlineIntroInclude Bug267 Bug268 Bug271 MatchVirtual \
 	  PctInClass IntroInAll Instantiation Slice NonInlineSliceInclude \
-	  Empty \
+	  Empty Bug316 Derived Base Bug323 GlobalIds AnonymousStuff \
+	  ForcedInclude Bug336 Bug353 Introspection CallAccess Bug418 \
 	  RepoInvalid RepoVersion
+
+# Doesn't work at the moment: Bug209
 
 ACMSGTESTS := RepoInvalid RepoVersion
