=== debian/changelog ===
aspectc++ (1:1.0-4) unstable; urgency=low

  * debian/rules: Build doxygen in binary-arch target until buildds call the
    build-arch target instead of build to avoid FTBFS.

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 30 Jun 2011 21:11:23 +0200

aspectc++ (1:1.0-3) unstable; urgency=low

  * Don't compress examples files
  * Install into correct paths
  * add notes for linking against libPuma.a
  * Don't install non-functional Makefiles in example directories
  * Drop -no-rtti and from CFLAGS
  * implement build-arch and build-indep target as suggested by debian policy
  * Honor 'nocheck' flag in DEB_BUILD_OPTIONS

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 30 Jun 2011 17:29:15 +0200

aspectc++ (1:1.0-2) unstable; urgency=low

  * apply patch from upstream to fix FTBFS on kFreeBSD
  * simplify Vcs-Bzr field

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 19 Apr 2011 21:59:07 +0200

aspectc++ (1:1.0-1) unstable; urgency=low

  * New upstream version
  * don't ignore errors in maintainer scripts
  * aspectc++.postinst: don't call ag++ with full path
  * prefer dh_prep over dh_clean -k
  * Add ${misc:Depends} dependencies
  * support parallel builds
  * bump standards version
  * bump debhelper compat level to 7
  * install all Puma samples
  * switch to source format 3.0 (quilt)
  
 -- Reinhard Tartler <siretart@tauware.de>  Mon, 18 Apr 2011 21:40:56 +0200

aspectc++ (1.0pre4~svn.20080711-1) unstable; urgency=low

  * new upstream snapshot.
  * include all upstream documentation. Clarifying emails regarding
    licensing has been included into debian/copyright.
  * reformat description following recomendations of
    http://www.debian.org/doc/debian-policy/ch-controlfields.html#s-f-Description
    (Closes: #480316)

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 07 Jul 2008 14:41:02 +0200

aspectc++ (1.0pre4~svn.20080409+dfsg-3) unstable; urgency=low

  * Fix another missing include, this time in Ag++/StdSystem.cc

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 10 Apr 2008 17:40:52 +0200

aspectc++ (1.0pre4~svn.20080409+dfsg-2) unstable; urgency=low

  * After another round of reviewing Bens diff, the NMU was correct after
    all.  Incorporating the Ppatch from
    http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=23;bug=417489
    Really Closes: #417489 this time.
  * reweave Puma with changes from previous change.
  * More cleanups in the Puma buildscripts: debian/rules honors now noopt in
    the variable DEB_BUILD_OPTIONS.
  * add Vcs-Bzr headers to debian/control.

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 10 Apr 2008 13:37:36 +0200

aspectc++ (1.0pre4~svn.20080409+dfsg-1) unstable; urgency=low

  * new upstream snapshot
    - now builds properly with GCC 4.3 (Closes: #417489, #424106)
    - uses bash in the ag++ testsuite (Closes: #373665)
    - explicitly not ACKing NMU from Ben Hutchings. Upstream has fixed
      the issues with GCC 4.3 independently
    - Now shipping prewoven puma sources directly in the orig.tar.gz (again)
    - remove unlicensed documentation.
  * bumbed standards version
  * use CURDIR instead of PWD, thanks lintian
  * updated maintainer record
  * add script and target for retrieving a clean upstream tarball
  * Incorporating and Acking NMU from Sandro Tosi. (Closes: #424106)
  * compile ac++ twice: one time with prewoven Puma, then reweave a copy
    of Puma, then build a new ac++ with the freshly woven Puma. This
    ensures that ac++ is actually able to compile itself (Closes: #474560)
  * ensure that the AspectC++ testsuite is using /bin/bash (Closes: #373665)
  * compile with -O2 instead of -O3. -O2 is likely to cause problems on
    non-mainstream architectures. Plus, add '-g' to compilation flags, so
    that a build with DEB_BUILD_OPTIONS='noopt' actually creates a package
    with debugging information.
  * add dependency on gsfonts for having proper fonts in the doxygen
    outputs.
  * Bump Standard version to 3.7.3 (no changes needed).
  * Use Homepage Field.
  * Move packages into correct sections: libpuma-doc -> doc,
    libpuma-dev -> libdevel.
  * simplify debian/rules a bit.
  * install (woven) Puma development headers into libpuma-dev.

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 10 Apr 2008 09:23:51 +0200

aspectc++ (0.99+1.0pre3-3.1) unstable; urgency=low

  * Non-maintainer upload

  [ Sandro Tosi ]
  * debian/rules
    - added removal of binary not cleaned (Closes: #424106)

  [ Ben Hutchings ]
  * Fixed recursive make invocations to avoid hiding failures
  * Added/changed #include and using directives for g++ 4.3
    (Closes: #417489) (partly by Martin Michlmayr)
  * Added missing parentheses in Puma::FilenameInfo::name()

 -- Ben Hutchings <ben@decadent.org.uk>  Sun, 06 Apr 2008 01:15:28 +0100

aspectc++ (0.99+1.0pre3-3) experimental; urgency=low

  * more cleanups in Puma/Makefile
  * removed Antonio from uploaders on his request. Thank you for your work!
  * bumped standards version to 3.7.2 (no changes needed)
  * Introduce new package: libpuma-dev, for direct use of the
    puma library (Closes: #369771)
  * Introduce new package: libpuma-doc, with updated doxygen.conf
    containing 2 examples (ccparser and cparser) and doxygen generated docs
  * Added circular build-depend on itself, testing if the ac++ binary is
    working on all architectures!
  * Merge patches from upstream for ag++, fixing command line handling and
    fixes in the testsuite.

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 12 Jun 2006 10:53:28 +0200

aspectc++ (0.99+1.0pre3-2ubuntu2) gutsy; urgency=low

  * Rebuild to deal with launchpad looping.

 -- LaMont Jones <lamont@ubuntu.com>  Thu, 11 Oct 2007 21:28:50 -0600

aspectc++ (0.99+1.0pre3-2ubuntu1) feisty; urgency=low

  * Rebuild for ldbl128 change (powerpc, sparc).
  * Set Ubuntu maintainer address.

 -- Matthias Klose <doko@ubuntu.com>  Thu,  1 Mar 2007 22:30:19 +0000

aspectc++ (0.99+1.0pre3-2) unstable; urgency=low


