## aspectc++ 1.0pre4~svn.20080409+dfsg

=== Puma/Makefile ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #-------------------------------------------------
 # variables 
 #-------------------------------------------------
+
+include files.mk
 
 ROOT    ?= $(shell pwd)
 TARGET  ?= linux-release
@@ -9,7 +11,6 @@
 MINUSJ  ?= 1 
 
 include vars.mk
-include files.mk
 
 LIBDIR  := $(ROOT)/lib/$(TARGET)
 GENDIR  := $(ROOT)/gen-$(RELEASE)
@@ -20,12 +21,11 @@
 STEP2   := $(GENDIR)/step2
 
 CONFIG  := $(GENDIR)/puma.cfg
-ACNEWREPO ?= $(GENDIR)/acpp.repo
 
 # exported variables
 export GENDIR INCDIR LIBDIR OBJDIR STEP1 STEP2
-export ROOT TARGET AC DONTWEAVE CONFIG MINUSJ ACNEWREPO
-export ORASOURCES LEMSOURCES SOURCES CSOURCES ASPECTS 
+export ROOT TARGET AC DONTWEAVE CONFIG MINUSJ
+export ORASOURCES LEMSOURCES SOURCES ASPECTS 
 
 # suppress reporting directory changes
 MAKE := $(MAKE) --no-print-directory
@@ -49,17 +49,20 @@
 	@echo 
 
 tools:
+	@echo "Making tools..."
 	@cd $(ROOT)/tools && $(MAKE)
 
 src: tools
+	@echo "Making library..."
 	@cd $(ROOT)/src && $(MAKE) $(MAKECMDGOALS)
 
 examples: src
+	@echo "Making examples..."
 	@cd $(ROOT)/examples && $(MAKE)
 
-doc:
-	@echo "Generating Puma reference manual..."
-	@doxygen doc/RefMan/doxygen.conf && echo "=> see doc/RefMan/html/index.html"
+doxygen:
+	@echo "Making Puma documentation with doxygen..."
+	@doxygen doc/doxygen.conf && echo "=> see doc/doxygen/html/index.html"
 
 install: src
 	@echo "Installing library and headers..."
@@ -77,14 +80,16 @@
 	@cd $(ROOT)/src && $(MAKE) clean
 
 tools-clean:
+	@echo "Making tools clean..."
 	@cd $(ROOT)/tools && $(MAKE) -s clean
 
 examples-clean:
+	@echo "Making examples clean..."
 	@cd $(ROOT)/examples && $(MAKE) -s clean
 
 docs-clean:
 	@echo "Making docs clean..."
-	@rm -rf $(ROOT)/doc/RefMan/html
+	@rm -rf $(ROOT)/doc/doxygen
 
 cleanall: test-clean examples-clean tools-clean docs-clean
 	@echo "Making completely clean..."
@@ -111,4 +116,4 @@
 #-------------------------------------------------
 
 .PHONY: all tools src install examples distclean cleanall \
-clean tools-clean examples-clean libclean weave compile uninstall doc
+clean tools-clean examples-clean libclean weave compile uninstall
