=== AspectC++/tests/Makefile ===
--- 
+++ 
@@ -3,8 +3,6 @@
 used directly. Please use the makefile in the toplevel \
 directory of the ApectC++ source tree instead)
 endif
-
-SHELL=/bin/bash
 
 ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
           Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
@@ -14,12 +12,11 @@
 	  AbstractDerivedAspect PragmaOnceObserver ThatConst PrivateResult \
           VoidArg ArrayWrapper Bug216 Bug228 ExecAdviceRecursive ExternC \
 	  ThatContext IntroIncludes Bug234 Bug234-2 Bug235 Bug239 \
-	  ExecAdviceNewDelete ExecAdviceFriend CallPostfixOp STLString \
-	  CFlowCycle Bug368 \
+	  ExecAdviceNewDelete CallPostfixOp STLString CFlowCycle \
 	  IntroInBase NonInlineIntroInclude Bug267 Bug268 Bug271 MatchVirtual \
 	  PctInClass IntroInAll Instantiation Slice NonInlineSliceInclude \
 	  Empty Bug316 Derived Base Bug323 GlobalIds AnonymousStuff \
-	  ForcedInclude Bug336 Bug353 Introspection CallAccess Bug418 \
+	  ForcedInclude Bug336 Bug353 \
 	  RepoInvalid RepoVersion
 
 # Doesn't work at the moment: Bug209
